﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfApplication258
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        void btnCheckSpelling_Click(object sender, RoutedEventArgs e)
        {
            SpellCheck(richTextBox.Document);
            //this.xamSpellChecker1.SpellCheck();

            //    xamSpellChecker1.SpellCheckDialog.a
        }

        private void xamSpellChecker1_Loaded(object sender, RoutedEventArgs e)
        {
           
        }

        private void xamSpellChecker1_SpellCheckCompleted(object sender, Infragistics.Controls.Interactions.SpellCheckCompletedEventArgs e)
        {
            MessageBox.Show("done");

        }


        private void  SpellCheck(FlowDocument document)
        {
            xamSpellChecker1.SpellCheckTargets.Clear();
            // Bind each run.Text in the document as a target for SpellChecker
            foreach (Block block in document.Blocks)
            {
                if (block is Paragraph)
                {
                    BindParagraph(block as Paragraph);
                }
                if (block is List)
                {
                    BindList(block as List);
                }
            }
            xamSpellChecker1.SpellCheck();
        }

        // Handle List binding
        private void BindList(List list)
        {
            foreach (ListItem item in list.ListItems)
            {
                foreach (Block block in item.Blocks)
                {
                    if (block is Paragraph)
                    {
                        BindParagraph(block as Paragraph);
                    }
                    if (block is List)
                    {
                        BindList(block as List);
                    }
                }
            }
        }

        // Handle Paragraph binding
        private void BindParagraph(Paragraph paragraph)
        {
            foreach (Inline inline in (paragraph).Inlines)
            {
                var run = inline as Run;
                if (run != null)
                {
                    BindRun(run);
                }
                var span = inline as Span;
                if (span != null)
                {
                    BindSpan(span);
                }
            }
        }

        // Handle Span binding
        private void BindSpan(Span span)
        {
            foreach (Inline inline in span.Inlines)
            {
                var run = inline as Run;
                if (run != null)
                {
                    BindRun(run);
                }
            }
        }

        // This is where the true binding to the SpellChecker is done 
        private void BindRun(Run run)
        {
            Binding binding = new Binding("Text");
            binding.Source = run;
            binding.Mode = BindingMode.TwoWay;
            xamSpellChecker1.SpellCheckTargets.Add(binding);
        }

    }
}
